require 'socket'
require 'timeout'

host = if ARGV[0] then ARGV[0] else 'localhost' end
port = if ARGV[1] then ARGV[1] else 'echo' end
sock = nil
timeout(20) {
  sock = TCPSocket.open(host, port)
}

while msg = STDIN.gets
  cnt = 0
  begin
    sock.write(msg)
    timeout(2) {
      print sock.gets
    }
  rescue TimeoutError
    if cnt < 3
      cnt += 1
      STDERR.print "... TIMEOUT ERROR!! (retry:#{cnt})\n"
      retry
    else
      raise
    end
  end
end
sock.close
